package cn.com.qmth.stmms.biz.exam.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import cn.com.qmth.stmms.common.annotation.ExcelField;

@Entity
@Table(name = "eb_marker_class")
public class MarkerClass implements Serializable {

    private static final long serialVersionUID = 5443691680600923462L;

    @Id
    @GeneratedValue
    private Integer id;

    @Column(name = "user_id")
    private Integer userId;

    @Column(name = "exam_id")
    @ExcelField(title = "考试ID", align = 2, sort = 20)
    private Integer examId;

    @ExcelField(title = "班级", align = 2, sort = 30)
    @Column(name = "class_name")
    private String className;

    @Transient
    @ExcelField(title = "登录名", align = 2, sort = 10)
    private String loginName;

    public MarkerClass(Integer userId, Integer examId, String className) {
        this.userId = userId;
        this.examId = examId;
        this.className = className;
    }

    public MarkerClass() {

    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

}
